"use strict";

var compareSnapshotCommand = function compareSnapshotCommand(defaultScreenshotOptions) {
  Cypress.Screenshot.defaults({
    screenshotOnRunFailure: false
  });
  Cypress.Commands.add('compareSnapshot', {
    prevSubject: 'optional'
  }, function (subject, name) {
    var testThreshold = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
    var screenshotOptions = defaultScreenshotOptions;
    var testName = "".concat(Cypress.spec.name.replace('.js', ''), " - ").concat(name); // take snapshot

    var objToOperateOn = subject ? cy.get(subject) : cy;
    objToOperateOn.screenshot(testName, screenshotOptions).task('copyScreenshot', {
      testName: testName
    }); // run visual tests

    var options = {
      testName: testName,
      testThreshold: testThreshold
    };
    cy.task('compareSnapshotsPlugin', options).then(function (percentage) {
      if (percentage > testThreshold) {
        throw new Error("The image difference percentage ".concat(percentage, " exceeded the threshold: ").concat(testThreshold));
      }
    });
  });
};

module.exports = compareSnapshotCommand;